/*
 * Infra Red protocols decoder
 * Author: Piotr Wjtowicz
 * 2016-2017
 * pw@elportal.pl
 */

#include "irdecoder.h"

sm_t sm;
irsm_t irsm;
frame_ret_t frame_ret;

const uint8_t sircBytesLen[2] = {7,5};

//=======================================================================
void sm_facade(uint8_t t, uint8_t state) {
    uint8_t i;
    const trans_t *p;
    for (i=0; i<sm.ntrans; i++) {
        p = &sm.trans[i];
        if (t >= p->tmin) {
            if(t <= p->tmax) {
                if(state == p->nextState) {
                    p->next_trans();
                    break;
                }
            }
        }
    }
}
//=======================================================================
void initsm() {
    irsm.bitCounter = 0;
    irsm.bitValueTmp = 0;

    irsm.data[0] = 0;
    irsm.data[1] = 0;
    irsm.data[2] = 0;
    irsm.data[3] = 0;
    irsm.field = 0;

    frame_ret.addr = 0;
    frame_ret.cmd = 0;

    sm.productReady = 0;
    sm.ntrans = 0;

    TROUT2 (
        TR(MAXT, MAXT, 0, decoderStateL),
        TR(MAXT, MAXT, 1, decoderStateH)
    );
    frame_ret.pt = NONE;
}

void decoderStateH() {
    TROUT5 (
        TR(US2TIME(889), EPS, 0, rc5L1state),
        TR(SIRC_PREAMBLE_HI, SIRC_EPS, 0, sircPreLstate),
        TR(NEC_PREAMBLE_HI, NEC_EPS, 0, necPreLstate),
        TR(MAXT, MAXT, 1, decoderStateH),
        TR(MAXT, MAXT, 0, initsm)
    );
}
// -----------------------------------------------
void decoderStateL() {
    TROUT2 (
        TR(MAXT, MAXT, 0, decoderStateL),
        TR(MAXT, MAXT, 1, decoderStateH)
    );
}
// -----------------------------------------------
